rc revision 59674
1#!/bin/sh
2# $FreeBSD: head/etc/rc 59674 2000-04-27 08:43:49Z sheldonh $
3#	From: @(#)rc	5.27 (Berkeley) 6/5/91
4
5# System startup script run by init on autoboot
6# or after single-user.
7# Output and error are redirected to console by init,
8# and the console is the controlling terminal.
9
10# Note that almost all of the user-configurable behavior is no longer in
11# this file, but rather in /etc/defaults/rc.conf.  Please check that file
12# first before contemplating any changes here.  If you do need to change
13# this file for some reason, we would like to know about it.
14
15stty status '^T'
16
17# Set shell to ignore SIGINT (2), but not children;
18# shell catches SIGQUIT (3) and returns to single user after fsck.
19#
20trap : 2
21trap : 3	# shouldn't be needed
22
23HOME=/
24PATH=/sbin:/bin:/usr/sbin:/usr/bin:/usr/local/sbin
25export HOME PATH
26
27# BOOTP diskless boot.  We have to run the rc file early in order to
28# retarget various config files.
29#
30if [ -r /etc/rc.diskless1 ]; then
31	dlv=`/sbin/sysctl -n vfs.nfs.diskless_valid 2> /dev/null`
32	if [ ${dlv:=0} != 0 ]; then
33		. /etc/rc.diskless1
34	fi
35fi
36
37# If there is a global system configuration file, suck it in.
38#
39if [ -r /etc/defaults/rc.conf ]; then
40	. /etc/defaults/rc.conf
41	source_rc_confs
42elif [ -r /etc/rc.conf ]; then
43	. /etc/rc.conf
44fi
45
46# Configure ccd devices.
47#
48if [ -r /etc/ccd.conf ]; then
49	ccdconfig -C
50fi
51
52case ${start_vinum} in
53[Yy][Ee][Ss])
54	vinum start
55	;;
56esac
57
58swapon -a
59
60case $1 in
61autoboot)
62	echo Automatic reboot in progress...
63	fsck -p
64	case $? in
65	0)
66		;;
67	2)
68		exit 1
69		;;
70	4)
71		reboot
72		echo "reboot failed... help!"
73		exit 1
74		;;
75	8)
76		echo "Automatic file system check failed... help!"
77		exit 1
78		;;
79	12)
80		echo "Reboot interrupted"
81		exit 1
82		;;
83	130)
84		# interrupt before catcher installed
85		exit 1
86		;;
87	*)
88		echo "Unknown error in reboot"
89		exit 1
90		;;
91	esac
92	;;
93*)
94	echo Skipping disk checks ...
95	;;
96esac
97
98set -T
99trap "echo 'Reboot interrupted'; exit 1" 3
100
101# root normally must be read/write, but if this is a BOOTP NFS
102# diskless boot it does not have to be.
103#
104case ${root_rw_mount} in
105[Nn][Oo] | '')
106	;;
107*)
108	if ! mount -u -o rw / ; then
109		echo "Mounting root filesystem rw failed, startup aborted"
110		exit 1
111	fi
112	;;
113esac
114
115umount -a >/dev/null 2>&1
116
117# Mount everything except nfs filesystems.
118mount -a -t nonfs
119
120case $? in
1210)
122	;;
123*)
124	echo "Mounting /etc/fstab filesystems failed, startup aborted"
125	exit 1
126	;;
127esac
128
129# Run custom disk mounting function here
130#
131if [ -n "${diskless_mount}" -a -r "${diskless_mount}" ]; then
132		sh ${diskless_mount}
133fi
134
135adjkerntz -i
136
137clean_var() {
138	if [ ! -f /var/run/clean_var ]; then
139		rm -rf /var/run/*
140		rm -f /var/spool/lock/*
141		rm -rf /var/spool/uucp/.Temp/*
142		# Keep a copy of the boot messages around
143		dmesg >/var/run/dmesg.boot
144		# And an initial utmp file
145		(cd /var/run && cp /dev/null utmp && chmod 644 utmp;)
146		>/var/run/clean_var
147	fi
148}
149
150if [ -d /var/run -a -d /var/spool/lock -a -d /var/spool/uucp/.Temp ]; then
151	# network_pass1() *may* end up writing stuff to /var - we don't want to
152	# remove it immediately afterwards - *nor* to we want to fail to clean
153	# an nfs-mounted /var.
154	clean_var
155fi
156
157# Add additional swapfile, if configured.
158#
159case ${swapfile} in
160[Nn][Oo] | '')
161	;;
162*)
163	if [ -w "${swapfile}" -a -c /dev/vn0b ]; then
164		echo "Adding ${swapfile} as additional swap."
165		vnconfig /dev/vn0b ${swapfile} && swapon /dev/vn0b
166	fi
167	;;
168esac
169
170# Set sysctl variables as early as we can
171#
172if [ -r /etc/rc.sysctl ]; then
173	. /etc/rc.sysctl
174fi
175
176# Configure serial devices
177#
178if [ -r /etc/rc.serial ]; then
179	. /etc/rc.serial
180fi
181
182# Start up PC-card configuration
183#
184if [ -r /etc/rc.pccard ]; then
185	. /etc/rc.pccard
186fi
187
188# Start up the initial network configuration.
189#
190if [ -r /etc/rc.network ]; then
191	. /etc/rc.network	# We only need to do this once.
192	network_pass1
193fi
194
195case ${ipv6_enable} in
196[Yy][Ee][Ss])
197	if [ -r /etc/rc.network6 ]; then
198		. /etc/rc.network6	# We only need to do this once also.
199		network6_pass1
200	fi
201	;;
202esac
203
204# Mount NFS filesystems if present in /etc/fstab
205if mount -d -a -t nfs | grep -q nfs >/dev/null 2>&1; then
206	echo -n "Mounting NFS file systems"
207	mount -a -t nfs
208	echo .
209fi
210
211# Whack the pty perms back into shape.
212#
213chflags 0 /dev/tty[pqrsPQRS]*
214chmod 666 /dev/tty[pqrsPQRS]*
215chown root:wheel /dev/tty[pqrsPQRS]*
216
217# Clean up left-over files
218#
219clean_var			# If it hasn't already been done
220rm /var/run/clean_var
221
222# Clearing /tmp at boot-time seems to have a long tradition.  It doesn't
223# help in any way for long-living systems, and it might accidentally
224# clobber files you would rather like to have preserved after a crash
225# (if not using mfs /tmp anyway).
226#
227# See also the example of another cleanup policy in /etc/periodic/daily.
228#
229case ${clear_tmp_enable} in
230[Yy][Ee][Ss])
231	echo clearing /tmp
232	# prune quickly with one rm, then use find to clean up /tmp/[lq]*
233	# (not needed with mfs /tmp, but doesn't hurt there...)
234	(cd /tmp && rm -rf [a-km-pr-zA-Z]* &&
235		find -d . ! -name . ! -name lost+found ! -name quota.user \
236		! -name quota.group -exec rm -rf -- {} \;)
237	;;
238esac
239
240# Remove X lock files, since they will prevent you from restarting X11
241# after a system crash.
242#
243rm -f /tmp/.X*-lock /tmp/.X11-unix/*
244
245# Snapshot any kernel -c changes back to disk here <someday>.
246# This has changed with ELF and /kernel.config.
247
248echo -n 'additional daemons:'
249
250# Start system logging and name service.  Named needs to start before syslogd
251# if you don't have a /etc/resolv.conf.
252#
253case ${syslogd_enable} in
254[Yy][Ee][Ss])
255	# Transitional symlink (for the next couple of years :) until all
256	# binaries have had a chance to move towards /var/run/log.
257	if [ ! -h /dev/log ]; then
258		# might complain for r/o root f/s
259		ln -sf /var/run/log /dev/log
260	fi
261
262	rm -f /var/run/log
263	echo -n ' syslogd';	syslogd ${syslogd_flags}
264	;;
265esac
266
267echo '.'
268
269# Enable dumpdev so that savecore can see it.
270# /var/crash should be a directory or a symbolic link
271# to the crash directory if core dumps are to be saved.
272#
273case ${dumpdev} in
274[Nn][Oo] | '')
275	;;
276*)
277	if [ -e "${dumpdev}" -a -d /var/crash ]; then
278		dumpon ${dumpdev}
279		echo -n checking for core dump...
280		savecore /var/crash
281	fi
282	;;
283esac
284
285if [ -n "${network_pass1_done}" ]; then
286	network_pass2
287fi
288
289# Enable/Check the quotas (must be after ypbind if using NIS)
290#
291case ${enable_quotas} in
292[Yy][Ee][Ss])
293	case ${check_quotas} in
294	[Yy][Ee][Ss])
295		echo -n 'checking quotas:'
296		quotacheck -a
297		echo ' done.'
298		;;
299	esac
300
301	echo -n 'enabling quotas:'
302	quotaon -a
303	echo ' done.'
304	;;
305esac
306
307if [ -n "${network_pass2_done}" ]; then
308	network_pass3
309fi
310
311# Build ps databases
312#
313dev_mkdb
314
315# Check the password temp/lock file
316#
317if [ -e /etc/ptmp ]; then
318	logger -s -p auth.err \
319	"password file may be incorrect -- /etc/ptmp exists"
320fi
321
322case ${accounting_enable} in
323[Yy][Ee][Ss])
324	if [ -d /var/account ]; then
325		echo 'turning on accounting'
326		if [ ! -e /var/account/acct ]; then
327			touch /var/account/acct
328		fi
329		accton /var/account/acct
330	fi
331	;;
332esac
333
334# Make shared lib searching a little faster.  Leave /usr/lib first if you
335# add your own entries or you may come to grief.
336#
337if [ -x /sbin/ldconfig ]; then
338	case `/usr/bin/objformat` in
339	elf)
340		_LDC=/usr/lib
341		for i in ${ldconfig_paths}; do
342			if [ -d "${i}" ]; then
343				_LDC="${_LDC} ${i}"
344			fi
345		done
346		echo 'setting ELF ldconfig path:' ${_LDC}
347		ldconfig -elf ${_LDC}
348		;;
349	esac
350
351	# Legacy aout support for i386 only
352	case `sysctl -n hw.machine` in
353	i386)
354		# Default the a.out ldconfig path.
355		: ${ldconfig_paths_aout=${ldconfig_paths}}
356		_LDC=/usr/lib/aout
357		for i in ${ldconfig_paths_aout}; do
358			if [ -d "${i}" ]; then
359				_LDC="${_LDC} ${i}"
360			fi
361		done
362		echo 'setting a.out ldconfig path:' ${_LDC}
363		ldconfig -aout ${_LDC}
364		;;
365	esac
366fi
367
368# Now start up miscellaneous daemons that don't belong anywhere else
369#
370echo -n starting standard daemons:
371case ${inetd_enable} in
372[Nn][Oo])
373	;;
374*)
375	echo -n ' inetd';	inetd ${inetd_flags}
376	;;
377esac
378
379case ${cron_enable} in
380[Nn][Oo])
381	;;
382*)
383	echo -n ' cron';	cron
384	;;
385esac
386
387case ${lpd_enable} in
388[Yy][Ee][Ss])
389	echo -n ' printer';	${lpd_program:-/usr/sbin/lpd} ${lpd_flags}
390	;;
391esac
392
393case ${sendmail_enable} in
394[Yy][Ee][Ss])
395	if [ -r /etc/mail/sendmail.cf ]; then
396		echo -n ' sendmail';	/usr/sbin/sendmail ${sendmail_flags}
397	fi
398	;;
399esac
400
401case ${sshd_enable} in
402[Yy][Ee][Ss])
403	if [ -x ${sshd_program:-/usr/sbin/sshd} ]; then
404		echo -n ' sshd';
405		${sshd_program:-/usr/sbin/sshd} ${sshd_flags}
406	fi
407	;;
408esac
409
410case ${usbd_enable} in
411[Yy][Ee][Ss])
412	echo -n ' usbd';	/usr/sbin/usbd ${usbd_flags}
413	;;
414esac
415
416echo '.'
417
418# Recover vi editor files.
419find /var/tmp/vi.recover ! -type f -a ! -type d -delete
420vibackup=`echo /var/tmp/vi.recover/vi.*`
421if [ "${vibackup}" != '/var/tmp/vi.recover/vi.*' ]; then
422	echo 'Recovering vi editor sessions'
423	for i in /var/tmp/vi.recover/vi.*; do
424		# Only test files that are readable.
425		if [ ! -r "${i}" ]; then
426			continue
427		fi
428
429		# Unmodified nvi editor backup files either have the
430		# execute bit set or are zero length.  Delete them.
431		if [ -x "${i}" -o ! -s "${i}" ]; then
432			rm -f "${i}"
433		fi
434	done
435
436	# It is possible to get incomplete recovery files, if the editor
437	# crashes at the right time.
438	virecovery=`echo /var/tmp/vi.recover/recover.*`
439	if [ "${virecovery}" != "/var/tmp/vi.recover/recover.*" ]; then
440		for i in /var/tmp/vi.recover/recover.*; do
441			# Only test files that are readable.
442			if [ ! -r "${i}" ]; then
443				continue
444			fi
445
446			# Delete any recovery files that are zero length,
447			# corrupted, or that have no corresponding backup file.
448			# Else send mail to the user.
449			recfile=`awk '/^X-vi-recover-path:/{print $2}' < "${i}"`
450			if [ -n "${recfile}" -a -s "${recfile}" ]; then
451				sendmail -t < "${i}"
452			else
453				rm -f "${i}"
454			fi
455		done
456	fi
457fi
458
459# Make a bounds file for msgs(1) if there isn't one already
460# "Delete important files with symlink" security hole?
461#
462if [ -d /var/msgs -a ! -f /var/msgs/bounds ]; then
463	echo 0 > /var/msgs/bounds
464fi
465
466case ${update_motd} in
467[Nn][Oo] | '')
468	;;
469*)
470	if T=`mktemp /tmp/_motd.XXXXXX`; then
471		uname -v | sed -e 's,^\([^#]*\) #\(.* [1-2][0-9][0-9][0-9]\).*/\([^\]*\) $,\1 (\3) #\2,' > ${T}
472		awk '{if (NR == 1) {if ($1 == "FreeBSD") {next} else {print "\n"$0}} else {print}}' < /etc/motd >> ${T}
473		cmp -s ${T} /etc/motd || {
474			cp ${T} /etc/motd
475			chmod 644 /etc/motd
476		}
477		rm -f ${T}
478	fi
479	;;
480esac
481
482# Configure implementation specific stuff
483#
484arch=`uname -m`
485if [ -r /etc/rc.${arch} ]; then
486	. /etc/rc.${arch}
487fi
488
489# Run rc.devfs if readable to customize devfs
490#
491if [ -r /etc/rc.devfs ]; then
492	sh /etc/rc.devfs
493fi
494
495# Do traditional (but rather obsolete) rc.local file if it exists.  If you
496# use this file and want to make it programmatic, source /etc/defaults/rc.conf
497# in /etc/rc.local and add your custom variables to /etc/rc.conf, as
498# shown below.  Please do not put local extensions into /etc/rc itself.
499# Use /etc/rc.local
500#
501# ---- rc.local ----
502#	if [ -r /etc/defaults/rc.conf ]; then
503#		. /etc/defaults/rc.conf
504#		source_rc_confs
505#	elif [ -r /etc/rc.conf ]; then
506#		. /etc/rc.conf
507#	fi
508#
509#	... additional startup conditionals ...
510# ---- rc.local ----
511#
512if [ -r /etc/rc.local ]; then
513	echo -n 'starting local daemons:'
514	sh /etc/rc.local
515	echo '.'
516fi
517
518# For each valid dir in $local_startup, search for init scripts matching *.sh
519#
520case ${local_startup} in
521[Nn][Oo] | '')
522	;;
523*)
524	echo -n 'Local package initialization:'
525	for dir in ${local_startup}; do
526		if [ -d "${dir}" ]; then
527			for script in ${dir}/*.sh; do
528				if [ -x "${script}" ]; then
529					(set -T
530					 trap 'exit 1' 2
531					 ${script} start)
532				fi
533			done
534		fi
535	done
536	echo .
537	;;
538esac
539
540if [ -n "${network_pass3_done}" ]; then
541	network_pass4
542fi
543
544# Raise kernel security level.  This should be done only after `fsck' has
545# repaired local file systems if you want the securelevel to be greater than 1.
546#
547case ${kern_securelevel_enable} in
548[Yy][Ee][Ss])
549	if [ "${kern_securelevel}" -ge 0 ]; then
550		echo 'Raising kernel security level'
551		sysctl -w kern.securelevel=${kern_securelevel}
552	fi
553	;;
554esac
555
556date
557exit 0
558